## ros-rolling-rttest 0.12.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rttest)

if(WIN32 OR APPLE OR ANDROID)
  message(STATUS "rttest is only supported on Linux, skipping...")
  return()
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake QUIET)

# ament build if it was found
if(${ament_cmake_FOUND})
  find_package(Threads REQUIRED)

  add_library(rttest SHARED src/rttest.cpp)
  target_link_libraries(rttest PRIVATE m stdc++ Threads::Threads)
  target_include_directories(rttest PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
    "$<INSTALL_INTERFACE:include>")

  ament_export_targets(export_rttest)

  if(BUILD_TESTING)
    find_package(ament_cmake_gtest REQUIRED)
    find_package(ament_lint_auto REQUIRED)
    ament_lint_auto_find_test_dependencies()

    ament_add_gtest(
      gtest_rttest_api
      "test/test_api.cpp"
      TIMEOUT 15
    )
    target_link_libraries(gtest_rttest_api rttest)

    ament_add_gtest(
      gtest_math_utils
      "test/test_math_util.cpp"
      TIMEOUT 15
    )
    target_link_libraries(gtest_math_utils rttest)
  endif()

  ament_package()

  install(
    DIRECTORY include/
    DESTINATION include
  )

  install(
    PROGRAMS scripts/rttest_plot
    DESTINATION bin
  )

  install(
    TARGETS rttest
    EXPORT export_rttest
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
  )

else()
  message(STATUS "ament_cmake_auto not found, executing pure CMake build")
  # pure cmake build
  set(INSTALL_LIB_DIR lib CACHE PATH "install dir for libraries")
  set(INSTALL_BIN_DIR bin CACHE PATH "install dir for executables")
  set(INSTALL_INCLUDE_DIR include CACHE PATH "install dir for headers")

  set(DEF_INSTALL_CMAKE_DIR lib/cmake/rttest)
  set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "install dir for cmake files")

  find_package(Threads REQUIRED)
  add_library(rttest ${PROJECT_SOURCE_DIR}/src/rttest.cpp)
  target_link_libraries(rttest m stdc++ ${CMAKE_THREAD_LIBS_INIT})

  include_directories(rttest ${PROJECT_SOURCE_DIR}/include)

  install(TARGETS rttest
    LIBRARY DESTINATION ${INSTALL_LIB_DIR}
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
  )

  install(
    DIRECTORY include/
    DESTINATION ${INSTALL_INCLUDE_DIR})

  export(PACKAGE ${PROJECT_NAME})

  set(rttest_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include)
  set(rttest_LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib)
  set(rttest_CMAKE_DIR
    ${CMAKE_INSTALL_PREFIX}/share/${CMAKE_PROJECT_NAME}/CMake)
  configure_file(${CMAKE_PROJECT_NAME}Config.cmake.in
    ${CMAKE_BINARY_DIR}/InstallFiles/${CMAKE_PROJECT_NAME}Config.cmake
    @ONLY)
  install(FILES
    ${CMAKE_BINARY_DIR}/InstallFiles/${CMAKE_PROJECT_NAME}Config.cmake
    DESTINATION ${rttest_CMAKE_DIR})

endif()

=== debian/changelog ===
ros-rolling-rttest (0.12.1-1focal) focal; urgency=high

  * Fix include order for cpplint (#113 <https://github.com/ros2/realtime_support/issues/113>)
  * Contributors: Jacob Perron

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 14 Jan 2022 08:00:00 -0000

ros-rolling-rttest (0.12.0-1focal) focal; urgency=high

  * Fixes for uncrustify 0.72 (#111 <https://github.com/ros2/realtime_support/issues/111>)
  * Mark dependent targets as PRIVATE (#112 <https://github.com/ros2/realtime_support/issues/112>)
  * Export modern CMake targets (#110 <https://github.com/ros2/realtime_support/issues/110>)
  * Contributors: Chris Lalancette, Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 17 Dec 2021 08:00:00 -0000

ros-rolling-rttest (0.11.0-1focal) focal; urgency=high

  * Fix up nonsensical handling of NULL in rttest_get_{params,statistics} (#107 <https://github.com/ros2/realtime_support/issues/107>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 18 Mar 2021 07:00:00 -0000

ros-rolling-rttest (0.10.1-1focal) focal; urgency=high

  * Remove "struct" from rttest_sample_buffer variable declaration. (#105 <https://github.com/ros2/realtime_support/issues/105>)
  * Convert the sample buffer to a vector. (#104 <https://github.com/ros2/realtime_support/issues/104>)
  * Use strdup instead of strlen/strcpy dance. (#100 <https://github.com/ros2/realtime_support/issues/100>)
  * Enable basic warnings in rttest (#99 <https://github.com/ros2/realtime_support/issues/99>)
  * Only copy an rttest_sample_buffer if it is not nullptr. (#98 <https://github.com/ros2/realtime_support/issues/98>)
  * Contributors: Audrow Nash, Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 08 Dec 2020 08:00:00 -0000

ros-rolling-rttest (0.10.0-1focal) focal; urgency=high

  * Convert timespec to uint64 not long and vice versa  (#94 <https://github.com/ros2/realtime_support/issues/94>) (#96 <https://github.com/ros2/realtime_support/issues/96>)
  * Fix standard deviation overflow(#95 <https://github.com/ros2/realtime_support/issues/95>) (#97 <https://github.com/ros2/realtime_support/issues/97>)
  * Contributors: y-okumura-isp

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 17 Jun 2020 07:00:00 -0000

ros-rolling-rttest (0.9.0-1focal) focal; urgency=high

  * Use std::bind instead of deprecated std::bind2nd (#93 <https://github.com/ros2/realtime_support/issues/93>)
  * Use a uint64_t to store the prefault_dynamic_size. (#90 <https://github.com/ros2/realtime_support/issues/90>)
  * Make dynamic prefault memory size configurable (#89 <https://github.com/ros2/realtime_support/issues/89>)
  * code style only: wrap after open parenthesis if not in one line (#88 <https://github.com/ros2/realtime_support/issues/88>)
  * Contributors: Chris Lalancette, Dirk Thomas, Michel Hidalgo, Roman Sokolkov

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 30 Apr 2020 07:00:00 -0000

ros-rolling-rttest (0.8.2-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 13 Nov 2019 08:00:00 -0000

ros-rolling-rttest (0.8.1-1focal) focal; urgency=high

  * Fix typo (#83 <https://github.com/ros2/realtime_support/issues/83>)
  * Contributors: Servando

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 23 Oct 2019 07:00:00 -0000

ros-rolling-rttest (0.8.0-1focal) focal; urgency=high

  * Switch the latency storage to int64_t (#82 <https://github.com/ros2/realtime_support/issues/82>)
  * Only return statistics if they have been calculated (#81 <https://github.com/ros2/realtime_support/issues/81>)
  * Remove non-package from ament_target_dependencies() (#79 <https://github.com/ros2/realtime_support/issues/79>)
  * Fix armhf build warnings (#78 <https://github.com/ros2/realtime_support/issues/78>)
  * Contributors: Chris Lalancette, Prajakta Gokhale, Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 26 Sep 2019 07:00:00 -0000

ros-rolling-rttest (0.7.1-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 08 May 2019 07:00:00 -0000

ros-rolling-rttest (0.7.0-1focal) focal; urgency=high

  * Add section about DCO to CONTRIBUTING.md
  * Install headers into the same location when ament_cmake is not used (#72 <https://github.com/ros2/realtime_support/issues/72>)
  * Contributors: Dirk Thomas

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 14 Apr 2019 07:00:00 -0000

ros-rolling-rttest (0.6.0-1focal) focal; urgency=high

  * Drop obsolete RTLinux (#68 <https://github.com/ros2/realtime_support/issues/68>)
    RTLinux is obsolete, and both commercial and GPL editions were no longer
    maintained. Through the use of the real-time Linux kernel patch
    PREEMPT_RT, support for full preemption of critical sections, interrupt
    handlers, and "interrupt disable" code sequences can be supported.
  * Contributors: Jim Huang

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 20 Nov 2018 08:00:00 -0000

ros-rolling-rttest (0.5.0-1focal) focal; urgency=high

  * Update the maintainer (#65 <https://github.com/ros2/realtime_support/issues/65>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 27 Jun 2018 07:00:00 -0000

ros-rolling-rttest (0.4.0-1focal) focal; urgency=high

  * Update style to match latest uncrustify (#57 <https://github.com/ros2/realtime_support/issues/57>)
  * 0.0.3
  * Update style to satisfy new flake8 plugins (#56 <https://github.com/ros2/realtime_support/issues/56>)
  * Use CMAKE_X_STANDARD and check compiler rather than platform
  * Comply with flake8 + flake8-import-order linters (#52 <https://github.com/ros2/realtime_support/issues/52>)
  * Require CMake 3.5
  * C++14 (#50 <https://github.com/ros2/realtime_support/issues/50>)
  * Remove usage of internal variables and noops (#43 <https://github.com/ros2/realtime_support/issues/43>)
  * Add schema to manifest files


=== debian/control ===
Source: ros-rolling-rttest
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rttest
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ros-workspace
Description: Instrumentation library for real-time performance testing

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rttest//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rttest 0.16.0

=== debian/changelog ===
ros-rolling-rttest (0.16.0-1jammy) jammy; urgency=high



 -- Brandon Ong <brandon@openrobotics.org>  Wed, 26 Apr 2023 16:00:00 -0000

ros-rolling-rttest (0.15.0-1jammy) jammy; urgency=high

  * [rolling] Update maintainers - 2022-11-07 (#121 <https://github.com/ros2/realtime_support/issues/121>)
  * Contributors: Audrow Nash

 -- Brandon Ong <brandon@openrobotics.org>  Mon, 13 Feb 2023 16:00:00 -0000

ros-rolling-rttest (0.14.1-1jammy) jammy; urgency=high

  * Addressing issues found in Humble testing (#116 <https://github.com/ros2/realtime_support/issues/116>)
  * Contributors: Michael Carroll

 -- Brandon Ong <brandon@openrobotics.org>  Mon, 12 Sep 2022 16:00:00 -0000

ros-rolling-rttest (0.14.0-1jammy) jammy; urgency=high



 -- Brandon Ong <brandon@openrobotics.org>  Thu, 28 Apr 2022 16:00:00 -0000

ros-rolling-rttest (0.13.0-1jammy) jammy; urgency=high

  * Install includes to include/${PROJECT_NAME} (#114 <https://github.com/ros2/realtime_support/issues/114>)
  * Contributors: Shane Loretz

 -- Brandon Ong <brandon@openrobotics.org>  Mon, 28 Feb 2022 16:00:00 -0000

ros-rolling-rttest (0.12.1-1jammy) jammy; urgency=high

  * Fix include order for cpplint (#113 <https://github.com/ros2/realtime_support/issues/113>)
  * Contributors: Jacob Perron

 -- Brandon Ong <brandon@openrobotics.org>  Thu, 13 Jan 2022 16:00:00 -0000

ros-rolling-rttest (0.12.0-1jammy) jammy; urgency=high

  * Fixes for uncrustify 0.72 (#111 <https://github.com/ros2/realtime_support/issues/111>)
  * Mark dependent targets as PRIVATE (#112 <https://github.com/ros2/realtime_support/issues/112>)
  * Export modern CMake targets (#110 <https://github.com/ros2/realtime_support/issues/110>)
  * Contributors: Chris Lalancette, Shane Loretz

 -- Brandon Ong <brandon@openrobotics.org>  Thu, 16 Dec 2021 16:00:00 -0000

ros-rolling-rttest (0.11.0-1jammy) jammy; urgency=high

  * Fix up nonsensical handling of NULL in rttest_get_{params,statistics} (#107 <https://github.com/ros2/realtime_support/issues/107>)
  * Contributors: Chris Lalancette

 -- Brandon Ong <brandon@openrobotics.org>  Wed, 17 Mar 2021 16:00:00 -0000

ros-rolling-rttest (0.10.1-1jammy) jammy; urgency=high

  * Remove "struct" from rttest_sample_buffer variable declaration. (#105 <https://github.com/ros2/realtime_support/issues/105>)
  * Convert the sample buffer to a vector. (#104 <https://github.com/ros2/realtime_support/issues/104>)
  * Use strdup instead of strlen/strcpy dance. (#100 <https://github.com/ros2/realtime_support/issues/100>)
  * Enable basic warnings in rttest (#99 <https://github.com/ros2/realtime_support/issues/99>)
  * Only copy an rttest_sample_buffer if it is not nullptr. (#98 <https://github.com/ros2/realtime_support/issues/98>)
  * Contributors: Audrow Nash, Chris Lalancette

 -- Brandon Ong <brandon@openrobotics.org>  Mon, 07 Dec 2020 16:00:00 -0000

ros-rolling-rttest (0.10.0-1jammy) jammy; urgency=high

  * Convert timespec to uint64 not long and vice versa  (#94 <https://github.com/ros2/realtime_support/issues/94>) (#96 <https://github.com/ros2/realtime_support/issues/96>)
  * Fix standard deviation overflow(#95 <https://github.com/ros2/realtime_support/issues/95>) (#97 <https://github.com/ros2/realtime_support/issues/97>)
  * Contributors: y-okumura-isp

 -- Brandon Ong <brandon@openrobotics.org>  Tue, 16 Jun 2020 16:00:00 -0000

ros-rolling-rttest (0.9.0-1jammy) jammy; urgency=high

  * Use std::bind instead of deprecated std::bind2nd (#93 <https://github.com/ros2/realtime_support/issues/93>)
  * Use a uint64_t to store the prefault_dynamic_size. (#90 <https://github.com/ros2/realtime_support/issues/90>)
  * Make dynamic prefault memory size configurable (#89 <https://github.com/ros2/realtime_support/issues/89>)
  * code style only: wrap after open parenthesis if not in one line (#88 <https://github.com/ros2/realtime_support/issues/88>)
  * Contributors: Chris Lalancette, Dirk Thomas, Michel Hidalgo, Roman Sokolkov

 -- Brandon Ong <brandon@openrobotics.org>  Wed, 29 Apr 2020 16:00:00 -0000

ros-rolling-rttest (0.8.2-1jammy) jammy; urgency=high



 -- Brandon Ong <brandon@openrobotics.org>  Tue, 12 Nov 2019 16:00:00 -0000

ros-rolling-rttest (0.8.1-1jammy) jammy; urgency=high

  * Fix typo (#83 <https://github.com/ros2/realtime_support/issues/83>)
  * Contributors: Servando

 -- Brandon Ong <brandon@openrobotics.org>  Tue, 22 Oct 2019 16:00:00 -0000

ros-rolling-rttest (0.8.0-1jammy) jammy; urgency=high

  * Switch the latency storage to int64_t (#82 <https://github.com/ros2/realtime_support/issues/82>)
  * Only return statistics if they have been calculated (#81 <https://github.com/ros2/realtime_support/issues/81>)
  * Remove non-package from ament_target_dependencies() (#79 <https://github.com/ros2/realtime_support/issues/79>)
  * Fix armhf build warnings (#78 <https://github.com/ros2/realtime_support/issues/78>)
  * Contributors: Chris Lalancette, Prajakta Gokhale, Shane Loretz

 -- Brandon Ong <brandon@openrobotics.org>  Wed, 25 Sep 2019 16:00:00 -0000

ros-rolling-rttest (0.7.1-1jammy) jammy; urgency=high



 -- Brandon Ong <brandon@openrobotics.org>  Tue, 07 May 2019 16:00:00 -0000

ros-rolling-rttest (0.7.0-1jammy) jammy; urgency=high

  * Add section about DCO to CONTRIBUTING.md
  * Install headers into the same location when ament_cmake is not used (#72 <https://github.com/ros2/realtime_support/issues/72>)
  * Contributors: Dirk Thomas

 -- Brandon Ong <brandon@openrobotics.org>  Sat, 13 Apr 2019 16:00:00 -0000

ros-rolling-rttest (0.6.0-1jammy) jammy; urgency=high

  * Drop obsolete RTLinux (#68 <https://github.com/ros2/realtime_support/issues/68>)
    RTLinux is obsolete, and both commercial and GPL editions were no longer
    maintained. Through the use of the real-time Linux kernel patch
    PREEMPT_RT, support for full preemption of critical sections, interrupt
    handlers, and "interrupt disable" code sequences can be supported.
  * Contributors: Jim Huang



=== debian/control ===
Source: ros-rolling-rttest
Section: misc
Priority: optional
Maintainer: Brandon Ong <brandon@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rttest
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-ros-workspace
Description: Instrumentation library for real-time performance testing

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
